#-----------------------------------------------------------------------------
# Gretel
# Copyright (c) 2004 David G. Drumright (Ockham)
# Oct 7, 2004
#-----------------------------------------------------------------------------
# Reads the DAT created by Hansel.
#-----------------------------------------------------------------------------

from Tkinter import *
import tkFileDialog
import poser
scene = poser.Scene()
import pickle
import os
root = Tk()

#-----------------------------------------------------------------------------

global MainRecord
SelItem=scene.CurrentActor()

#-----------------------------------------------------------------------------

class App:
	def __init__(self, master, textMessage):
		self.master = master
		master.title("Gretel")
		self.DirVar=IntVar()

		self.TopFrame=Frame(self.master,borderwidth=2,relief=RIDGE)
		self.TopFrame.grid(row=1,column=0)
		self.BotFrame=Frame(self.master,borderwidth=2,relief=RIDGE)
		self.BotFrame.grid(row=3,column=0)

		self.StatusEntry = Entry(self.TopFrame,width=70)
		self.StatusEntry.grid(row=0,column=0,columnspan=3)
		self.StatusEntry.insert(0,"First pick a DAT file made by Hansel.")
		self.XZcheck=Radiobutton(self.TopFrame,text="XZ",var=self.DirVar,value=0)
		self.XZcheck.grid(row=2,column=2)
		self.XYcheck=Radiobutton(self.TopFrame,text="XY",var=self.DirVar,value=1)
		self.XYcheck.grid(row=3,column=2)
		self.YZcheck=Radiobutton(self.TopFrame,text="YZ",var=self.DirVar,value=2)
		self.YZcheck.grid(row=4,column=2)
		self.DirVar.set(0)

		# Go/nogo buttons.
		self.ButtonName = Button(self.TopFrame, text="Pick file", command=self.HandleName)
		self.ButtonName.grid(row=1, column=0,sticky=E+W)

		Label(self.TopFrame, text="Start frame:" ).grid(row=2, sticky=W)
		self.StartEntry = Entry(self.TopFrame, width=5)
		self.StartEntry.grid(row=2, column=1)
		self.StartEntry.insert(0,str(1))

		Label(self.TopFrame, text="End frame:" ).grid(row=3, sticky=W)
		self.EndEntry = Entry(self.TopFrame, width=5)
		self.EndEntry.grid(row=3, column=1)
		self.EndEntry.insert(0,str(scene.NumFrames()))

		Label(self.TopFrame, text="Lift (y):" ).grid(row=4, sticky=W)
		self.LiftEntry = Entry(self.TopFrame, width=5)
		self.LiftEntry.grid(row=4, column=1)
		self.LiftEntry.insert(END,"0.0")

		self.ButtonGo = Button(self.BotFrame, text="Go", command=self.HandleGo)
		self.ButtonGo.grid(row=0, column=0)
		self.ButtonCancel = Button(self.BotFrame, text="Cancel", command=self.HandleCancel)
		self.ButtonCancel.grid(row=0, column=2)

		self.master.protocol('WM_DELETE_WINDOW', self.HandleCancel)

	# - - - - - - - - - - - - - - - - - -

	def ShowStatus(self,S): # Just saving repetition
		self.StatusEntry.delete(0,END)
		self.StatusEntry.insert(0,S)
		self.StatusEntry.update_idletasks()

	# - - - - - - - - - - - - - - - - - -
	def HandleName(self):
		global FullFileName
		global MainRecord


		# Pop up file box to get name.
		BasePathUncut=poser.AppLocation()
		BasePath=BasePathUncut[:(-len('poser.exe'))]
		MyPath=os.path.normpath(BasePath+'/runtime/*.DAT') # Use this for release
		fn=tkFileDialog.askopenfilename(initialfile=MyPath, filetypes=[("DAT file", "*.DAT *.dat")] )

		if not fn:
			self.ShowStatus("No file selected. Try again.")
			return 0

		# Open the file
		FullFileName=os.path.abspath(fn)
		fp=open(FullFileName,'r')
		MainRecord=pickle.load(fp)
		fp.close()
		self.ShowStatus("Now set the start and end frames and Lift, then hit Go.")

	# - - - - - - - - - - - - - - - - - -

	def HandleGo(self):
		global FullFileName
		global MainRecord
		# Convert the time.  The DAT file is in ms, so we need a factor
		# to convert ms to frames.	We have the desired total frames.
		# The total ms is the time part of the last thing in the array.
		SF=self.StartEntry.get()
		if SF: StartFrame=int(SF)
		else:  StartFrame=1
		EF=self.EndEntry.get()
		if EF: EndFrame=int(EF)
		else:  EndFrame=scene.NumFrames()
		TotalFrames=EndFrame-StartFrame+1

		L =self.LiftEntry.get()
		if L: Lift=float(L)
		else:  Lift=0.0
		Mode=self.DirVar.get()
		# 0=XZ (flat) 1=XY, 2=YZ


		# We need to do MS * Factor = Frame, so Factor must be Frame/MS.
		(TotalMS,X,Y,Status)=MainRecord[-1]  #Fetch the last member
		factorT=TotalFrames/float(TotalMS)

		# Scale the drawn X and Z to the size of GROUND.
		realX = scene.Actor('GROUND').ParameterByCode(poser.kParmCodeXSCALE).Value()
		realZ = scene.Actor('GROUND').ParameterByCode(poser.kParmCodeZSCALE).Value()
		realA = scene.Actor('GROUND').ParameterByCode(poser.kParmCodeASCALE).Value()
		# The 200 here is the size of the Canvas in Hansel.  Probably should do
		# a max-min loop, but not sure yet.......
		factorX=realX*realA/200.0
		factorZ=realZ*realA/200.0

		# Get the parms of selected item.
		Xparm=SelItem.ParameterByCode(poser.kParmCodeXTRAN)
		Yparm=SelItem.ParameterByCode(poser.kParmCodeYTRAN)
		Zparm=SelItem.ParameterByCode(poser.kParmCodeZTRAN)
		startY=Yparm.Value() # So the lift will have a default
		LiftStartFrame=0 # So we can round off the lifts

		# Get the starting point of the record, and make the moves relative
		# to this point.
		(dummyMS,startX,startZ,Status)=MainRecord[0]  #Fetch the first member

		if Mode==0: # XZ default
			for (MS,X,Z,Status) in MainRecord:
				if Status==6: break
				Frame=StartFrame+int(factorT * float(MS))
				scene.SetFrame(Frame-1)
				Xparm.SetValue(factorX*(float(X)-startX))
				Zparm.SetValue(factorZ*(float(Z)-startZ))
				if Status==5:  # In lift
					Yparm.SetValue(startY+Lift)
				else:		   # In lift
					Yparm.SetValue(startY)
				if Status==4: # Start of lift. Just mark the frame so we can go back.
					LiftStartFrame=Frame
					Yparm.SetSplineBreak(Frame)
				if Status==2:
					# End of lift, start of new trace. Go back and de-key the lift
					# period except for the midpoint.
					Midpoint=(Frame+LiftStartFrame)/2
					for SubFrame in range(LiftStartFrame,Frame):
						if SubFrame!=Midpoint:
							Yparm.DeleteKeyFrame(SubFrame)



		elif Mode==1: # XY
			for (MS,X,Z,Status) in MainRecord:
				if Status==6: break
				Frame=StartFrame+int(factorT * float(MS))
				scene.SetFrame(Frame-1)
				Xparm.SetValue(factorX*(float(X)-startX))
				Yparm.SetValue(-factorZ*(float(Z)-startZ))
				if Status==5:  # In lift
					Zparm.SetValue(startY+Lift)
				else:		   # In lift
					Zparm.SetValue(startY)
				if Status==4: # Start of lift. Just mark the frame so we can go back.
					LiftStartFrame=Frame
					Zparm.SetSplineBreak(Frame)
				if Status==2:
					# End of lift, start of new trace. Go back and de-key the lift
					# period except for the midpoint.
					Midpoint=(Frame+LiftStartFrame)/2
					for SubFrame in range(LiftStartFrame,Frame):
						if SubFrame!=Midpoint:
							Zparm.DeleteKeyFrame(SubFrame)

		elif Mode==2: # YZ
			for (MS,X,Z,Status) in MainRecord:
				if Status==6: break
				Frame=StartFrame+int(factorT * float(MS))
				scene.SetFrame(Frame-1)
				Yparm.SetValue(-factorX*(float(Z)-startZ))
				Zparm.SetValue(factorZ*(float(X)-startX))
				if Status==5:  # In lift
					Xparm.SetValue(startY+Lift)
				else:		   # In lift
					Xparm.SetValue(startY)
				if Status==4: # Start of lift. Just mark the frame so we can go back.
					LiftStartFrame=Frame
					Xparm.SetSplineBreak(Frame)
				if Status==2:
					# End of lift, start of new trace. Go back and de-key the lift
					# period except for the midpoint.
					Midpoint=(Frame+LiftStartFrame)/2
					for SubFrame in range(LiftStartFrame,Frame):
						if SubFrame!=Midpoint:
							Xparm.DeleteKeyFrame(SubFrame)
		self.master.destroy()


	# - - - - - - - - - - - - - - - - - -

	def HandleCancel(self):
		self.master.destroy()

#------------------------------------------------------------
# Activate the loop
#------------------------------------------------------------

app = App(root, '')
root.mainloop()

#------------------------------------------------------------
# End TK loop.
#-----------------------------------------------------------------------------
